# Aknakereső 1.1 
import turtle
import random
turtle.speed(0)
turtle.tracer(0)
turtle.hideturtle()
screen = turtle.Screen()
screen.title("Minesweeper 1.1 // www.miskei.hu")
screen.bgcolor('lightgray')

osz = 18
ssz = 12
asz = 30

screen.setup((osz+2) * 40, (ssz+2) * 40)
screen.setworldcoordinates(0,(ssz+2) * 40 ,(osz+2) * 40,0)
mezo = [[turtle.Turtle() for i in range(osz + 2)] for j in range(ssz + 2)]
akna = [[0 for i in range(osz + 2)] for j in range(ssz + 2)]
szom = [[0 for i in range(osz + 2)] for j in range(ssz + 2)]
jel = [[0 for i in range(osz + 2)] for j in range(ssz + 2)]
szin = ["white", "blue", "green", "red", "darkblue", "darkgreen", "darkred", "peru", "brown"]
jelz = "💣"
felf = []
stilus = ('Courier', 22, 'bold')

def nullaz():
    for i in range(0, ssz + 2):
        for j in range(0, osz + 2):
            akna[i][j]=0
            szom[i][j]=0
            jel[i][j]=0

def kitakar():
    for i in range(0, ssz + 2):
        for j in range(0, osz + 2):
            mezo[i][j].hideturtle()

def takar():        
    for i in range(1, ssz + 1):
        for j in range(1, osz + 1):
            mezo[i][j].penup()
            mezo[i][j].color("azure2","azure4")
            mezo[i][j].shape("square")
            mezo[i][j].shapesize(1.7,1.7)
            mezo[i][j].setposition(j * 40 + 20, i * 40 + 20)
            mezo[i][j].showturtle()
            mezo[i][j].speed(0)
              
def palya():
    turtle.penup()
    for i in range(1, ssz + 1):
        for j in range(1, osz + 1):
            turtle.setposition(j * 40 + 20, i * 40 + 40)
            if szom[i][j] != 0:
                turtle.pencolor(szin[szom[i][j]])
                turtle.write(szom[i][j], font=stilus, align="center")
            if akna[i][j] == 1:
                turtle.pencolor("black")
                turtle.write(jelz, font=stilus, align="center")
    
def racs():
    turtle.pencolor("gray")
    turtle.pensize(3)
    turtle.hideturtle()
    for i in range(40, (osz + 2) * 40, 40):
        turtle.penup()
        turtle.setpos(i, 40)
        turtle.pendown()
        turtle.setpos(i, (ssz + 1) * 40)
    for i in range(40, (ssz + 2) * 40, 40):
        turtle.penup()
        turtle.setpos(40 , i)
        turtle.pendown()
        turtle.setpos((osz + 1) * 40, i)
    turtle.penup()

def aknasit(s,o):
    db = 0
    while asz != db:
        x = random.randint(1, osz)
        y = random.randint(1, ssz)
        d = ((s-y) ** 2 + (o - x) ** 2) ** 0.5
        if akna[y][x] == 0 and d > 3.5:
            db = db + 1
            akna[y][x] = 1

def szomszedok():
    for i in range(1, ssz + 1):
        for j in range(1, osz + 1):
            if akna[i][j] == 0:
                szum1 = akna[i-1][j-1] + akna[i-1][j] + akna[i-1][j + 1]
                szum2 = akna[i][j-1] + akna[i][j + 1]
                szum3 = akna[i+1][j-1] + akna[i+1][j] + akna[i+1][j + 1]
                szom[i][j] = szum1 + szum2 + szum3

    for i in range(0, ssz + 2):
         szom[i][0] = 8
         szom[i][osz+1] = 8
    for i in range(0, osz + 2):
         szom[0][i] = 8
         szom[ssz+1][i] = 8    

def felfed(s,o):
    ures = False
    while ures == False:
        for x in range(-1,2):
            for y in range(-1,2):
                us = s + x
                uo = o + y
                poz = (us, uo)
                mezo[us][uo].hideturtle()              
                if szom[us][uo] == 0 and akna[us][uo] != 8:
                    if felf.count(poz)==0:
                        felf.append(poz)
                akna[us][uo] = 8
                                
        if len(felf) == 0:
            ures = True
            for i in range(1, ssz + 1):
                for j in range(1, osz + 1):
                    turtle.setposition(j * 40 + 20, i * 40 + 40)
                    if szom[i][j] != 0 and akna[i][j] == 8:
                        turtle.pencolor(szin[szom[i][j]])
                        turtle.write(szom[i][j], font=stilus, align="center")
        else:
            poz = felf.pop(0)
            s = poz[0]
            o = poz[1]

def ellenoriz():
    global kezdes, vesztett
    if vesztett == False:
        talalt = 0
        felfedett = 0
        jelolt = 0
        for i in range(1, ssz + 1):
            for j in range(1, osz + 1):
                if jel[i][j] == 1:
                    jelolt += 1
                if akna[i][j] == 8:
                    felfedett += 1
                if jel[i][j] == 1 and akna[i][j] == 1:
                    talalt += 1
                screen.title("Aknák = " + str(asz - jelolt))
        if osz * ssz - asz == felfedett:
            screen.title("Gratulálok !!!")
            kezdes = True
    else:
        screen.title("Vesztettél !!!")
        
def kivalaszt(x,y):
    global kezdes, vesztett
    s = int(y) // 40
    o = int(x) // 40
    if s > 0 and o >0 and s <= ssz and o <= osz:
        if kezdes == True:
            vesztett = False
            nullaz()
            turtle.clear()
            racs()
            aknasit(s,o)
            szomszedok()
            # palya()
            takar()
            felfed(s,o)
            screen.title("")
            kezdes = False
        else:
            mezo[s][o].hideturtle()
            turtle.update()
            turtle.penup()
            turtle.setposition(o * 40 + 20, s * 40 + 40)
            if szom[s][o] != 0:
                akna[s][o] = 8
                turtle.pencolor(szin[szom[s][o]])
                turtle.write(szom[s][o], font=stilus, align="center")
            if akna[s][o] == 1:
                kitakar()
                palya()
                kezdes = True
                vesztett = True
                turtle.update()
                
            if szom[s][o] == 0 and akna[s][o] == 0:
                felfed(s,o)
        turtle.update()
        ellenoriz()

def torol(x,y):
    s = int(y) // 40
    o = int(x) // 40
    if s > 0 and o >0 and s <= ssz and o <= osz and kezdes == False:
        if jel[s][o] == 0:
            jel[s][o] =1
            mezo[s][o].color("azure2", "red")
        else:
            jel[s][o] =0
            mezo[s][o].color("azure2", "azure4")
        turtle.update()
        ellenoriz()

racs()
kitakar()
# takar()
kezdes = True
vesztett = False
turtle.update()
screen.onclick(torol,3)
screen.onclick(kivalaszt)
screen.mainloop()
# ************2023.03.03.************Miskei Vendel************www.miskei.hu************